import { IQueryHandler, QueryHandler } from '@nestjs/cqrs';
import { Inject } from '@nestjs/common';
import { USER_REPOSITORY } from '@modules/user/user.di-tokens';
import { UserRepositoryPort } from '../../ports/user.repository.port';
import { UserEntity } from '@modules/user/core/domain/user.entity';
import { FindUsersByIdsQuery } from './find-users-by-ids.query';

@QueryHandler(FindUsersByIdsQuery)
export class FindUsersByIdsQueryHandler implements IQueryHandler {
  constructor(
    @Inject(USER_REPOSITORY)
    private readonly userRepository: UserRepositoryPort,
  ) {}
  async execute(query: FindUsersByIdsQuery): Promise<UserEntity[]> {
    return await this.userRepository.findAllByIds(query.ids);
  }
}
